# SPDX-FileCopyrightText: Copyright (c) 2024, Linaro Limited.
#
# SPDX-License-Identifier: MIT
---

device_type: kv260
job_name: {{ CI_JOB_NAME }}
timeouts:
  job:
    minutes: 130

{%- if FREQUENCY == 'adhoc' %}
priority: medium
{%- else %}
priority: low
{%- endif %}
visibility: public

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/zynqmp-kria-starter-psa/ptest.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: GITLAB_PRIVATE_TOKEN
      header: "PRIVATE-TOKEN"
      dataset: minimal

secrets:
  ARTIFACTORY_PASS: ARTIFACTORY_PASS
  ARTIFACTORY_USER: ARTIFACTORY_USER

context:
  boot_character_delay: 30
  test_character_delay: 30
  extra_kernel_args: rootwait

actions:
# Flash firmware and distro images and reset the device
- deploy:
    timeout:
      minutes: 40
    to: flasher
    images:
      ImageA:
        url: "{{ FIRMWARE_ARTIFACT }}"
        compression: gz
      ImageB:
        url: "{{ FIRMWARE_ARTIFACT }}"
        compression: gz
      sd:
        url: "{{ IMAGE_ARTIFACT }}"
        compression: gz
        partition: 1
        format: ext4
        overlays:
          lava: true

- boot:
    parameters:
      kernel-start-message: ''
    timeout:
      minutes: 15
    method: minimal

# Boot until login prompt is reached, switch to root user
# and wait until device is fully online (to avoid timeout
# errors in k3s tests)
- boot:
    parameters:
      kernel-start-message: ''
    timeout:
      minutes: 10
    method: minimal
    reset: false
    auto_login:
      login_prompt: 'zynqmp-kria-starter-psa login:.*'
      username: cassini
      login_commands:
      - cassini123
      - cassini123
      - sudo su -
    prompts:
      - 'New password: '
      - 'Re-enter new password: '
      - '@zynqmp-kria-starter-psa:.+\$ '
      - '@zynqmp-kria-starter-psa:.+# '

# Run integration tests
- test:
    timeout:
      minutes: 60
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: cassini-integration-tests
            description: "Run Cassini integration tests"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - timedatectl
              - sudo systemctl restart systemd-timesyncd.service
              - timedatectl
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner user-accounts-integration-tests"
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner container-engine-integration-tests"
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 1200 parsec-openssl-provider-tests"
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 600 psa-arch-tests"
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 600 parsec-simple-e2e-tests"
              - |
                if [ -e /usr/lib/k3s-integration-tests/ptest ]; then
                  lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 600 k3s-integration-tests"
                fi
              - sudo chown -R test:test /home/test/runtime-integration-tests-logs
        from: inline
        name: cassini-integration-tests
        path: inline/cassini-integration-tests.yaml

# Upload results to artifactory
- test:
    docker:
      image: {{ UTILITY_IMAGE }}
    timeout:
      minutes: 3
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: Upload-results-from-DUT
            description: "Upload results from DUT"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - export TEST_LOGS="/home/test/runtime-integration-tests-logs"
              - mkdir -p $TEST_LOGS
              - export TARGET_IP=$TARGET_DEVICE_IP
              - scp -o "StrictHostKeyChecking no" test@$TARGET_IP:$TEST_LOGS/* $TEST_LOGS/
              - |
                set +x; \
                . /lava-${LAVA_JOB_ID}/secrets && \
                jfrog config add \
                  --insecure-tls=true artifactory-aws \
                  --interactive=false \
                  --artifactory-url={{ ARTIFACTORY_URL }} \
                  --user=${ARTIFACTORY_USER} \
                  --password=${ARTIFACTORY_PASS}
              - set -x;
              - |
                cat << EOF > ./upload_spec.json
                {
                  "files": [
                    {
                      "pattern": "${TEST_LOGS}/",
                      "target": "{{ ARTIFACTORY_NAMESPACE }}.{{ ARTIFACTORY_TMP_REPO }}/{{ CI_PROJECT_NAME }}/{{ CI_JOB_ID }}/ptest-runner-results/",
                      "flat": "true",
                      "recursive": "true"
                    }
                  ]
                }
                EOF
              - build_name="{{ ARTIFACTORY_NAMESPACE }}/{{ CI_PROJECT_PATH }}/{{ CI_JOB_NAME }}"
              - jfrog rt upload --insecure-tls=true --spec=upload_spec.json --build-name="${build_name}" --build-number="{{ CI_JOB_ID }}"
              # Collect environment variables and attach them to a build.
              - jfrog rt build-collect-env "${build_name}" "{{ CI_JOB_ID }}"
              # Publish build info to Artifactory and discard old builds
              - |
                jfrog rt build-publish "${build_name}" "{{ CI_JOB_ID }}"  --build-url="{{ CI_PROJECT_URL }}" &&
                jfrog rt build-discard "${build_name}" --max-builds=10 --max-days=30 --delete-artifacts --async ||
                echo "Info: build info not supported by Artifactory"
              - cat /root/.jfrog/logs/jfrog-cli.*.log || true
        from: inline
        name: Upload-results-from-DUT
        path: inline/Upload-results-from-DUT.yaml

